
#include <cstdio>
#include <cstdlib>
#include<iostream>
#include "Timer.h"
#include "Random.h"
#include "da_set.h"
#include <set>

using namespace std;


void report(const da_set<int> &s)
{
  // Questa non ha nessun bisogno di essere un template, se non
  // per il fatto di svincolarsi dalla typedef all'inizio del main()

  std::cout << "Capacity :" << s.capacity() << std::endl;
  std::cout << "Size     :" << s.size() << std::endl;

  da_set<int>::const_iterator si, se;
  si = s.begin(); se = s.end();
  for (; si != se; ++si) std::cout << *si << " ";
  std::cout << std::endl;

  std::cout << std::endl;
}

int main()
{
  typedef da_set<int> DA_Set;

  DA_Set das(10);
  DA_Set::iterator si, se;

  das.insert(5);
  das.insert(7);
  das.insert(3);
  das.insert(4);

  report(das);

  DA_Set das2 = das;
  das.erase(7);

  report(das);
  report(das2);

  das2.erase(5);
  report(das2);

  das.insert(1);
  report(das);


  Timer time;
  Random rg;
  int r;
  time.resetTime();


  set<int> b;

  for (int j = 0; j < 10000000; j++)
    {
      for (int i = 0; i < 100; i++)
	{
	  b.insert(r);
	}

      for (int i = 99; i >= 0; i--)
	{
	  r = rg.ran0N(b.size()-1);
	  set<int>::iterator p = b.begin();
	  int l = 0;
	  while (l<r ) {++p; l++;};
	  int g = *p;
	}
       for (int i = 99; i >= 0; i--)
	{
	  b.erase(i);
	}
    }

  cout<< time.elapsedTime( )<<endl;

  time.resetTime();

  DA_Set a(100);

  for (int j = 0; j < 10000000; j++)
    {
      for (int i = 0; i < 100; i++)
	a.insert(i);

      for (int i = 99; i >= 0; i--)
	{
	  r = rg.ran0N(a.size()-1);
	  //a.erase(a[r]);
	  int g = a[r];
	}
      for (int i = 99; i >= 0; i--)
	{
	  a.erase(i);
	}
    }

  cout<< time.elapsedTime(  )<<endl;



}

//on isolde:
//358.194
//170.143

